/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the AuthenticationProviderDescription type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AuthenticationProviderDescription{}

// AuthenticationProviderDescription struct for AuthenticationProviderDescription
type AuthenticationProviderDescription struct {
	Id                               *string               `json:"id,omitempty"`
	DisplayName                      NullableString        `json:"displayName,omitempty"`
	Description                      NullableString        `json:"description,omitempty"`
	PropertyDescriptions             []PropertyDescription `json:"propertyDescriptions,omitempty"`
	AuthenticationProviderIdentifier NullableString        `json:"authenticationProviderIdentifier,omitempty"`
}

// NewAuthenticationProviderDescription instantiates a new AuthenticationProviderDescription object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAuthenticationProviderDescription() *AuthenticationProviderDescription {
	this := AuthenticationProviderDescription{}
	return &this
}

// NewAuthenticationProviderDescriptionWithDefaults instantiates a new AuthenticationProviderDescription object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAuthenticationProviderDescriptionWithDefaults() *AuthenticationProviderDescription {
	this := AuthenticationProviderDescription{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *AuthenticationProviderDescription) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AuthenticationProviderDescription) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *AuthenticationProviderDescription) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *AuthenticationProviderDescription) SetId(v string) {
	o.Id = &v
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderDescription) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderDescription) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *AuthenticationProviderDescription) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *AuthenticationProviderDescription) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *AuthenticationProviderDescription) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *AuthenticationProviderDescription) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderDescription) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderDescription) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *AuthenticationProviderDescription) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *AuthenticationProviderDescription) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *AuthenticationProviderDescription) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *AuthenticationProviderDescription) UnsetDescription() {
	o.Description.Unset()
}

// GetPropertyDescriptions returns the PropertyDescriptions field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderDescription) GetPropertyDescriptions() []PropertyDescription {
	if o == nil {
		var ret []PropertyDescription
		return ret
	}
	return o.PropertyDescriptions
}

// GetPropertyDescriptionsOk returns a tuple with the PropertyDescriptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderDescription) GetPropertyDescriptionsOk() ([]PropertyDescription, bool) {
	if o == nil || IsNil(o.PropertyDescriptions) {
		return nil, false
	}
	return o.PropertyDescriptions, true
}

// HasPropertyDescriptions returns a boolean if a field has been set.
func (o *AuthenticationProviderDescription) HasPropertyDescriptions() bool {
	if o != nil && !IsNil(o.PropertyDescriptions) {
		return true
	}

	return false
}

// SetPropertyDescriptions gets a reference to the given []PropertyDescription and assigns it to the PropertyDescriptions field.
func (o *AuthenticationProviderDescription) SetPropertyDescriptions(v []PropertyDescription) {
	o.PropertyDescriptions = v
}

// GetAuthenticationProviderIdentifier returns the AuthenticationProviderIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *AuthenticationProviderDescription) GetAuthenticationProviderIdentifier() string {
	if o == nil || IsNil(o.AuthenticationProviderIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.AuthenticationProviderIdentifier.Get()
}

// GetAuthenticationProviderIdentifierOk returns a tuple with the AuthenticationProviderIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *AuthenticationProviderDescription) GetAuthenticationProviderIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AuthenticationProviderIdentifier.Get(), o.AuthenticationProviderIdentifier.IsSet()
}

// HasAuthenticationProviderIdentifier returns a boolean if a field has been set.
func (o *AuthenticationProviderDescription) HasAuthenticationProviderIdentifier() bool {
	if o != nil && o.AuthenticationProviderIdentifier.IsSet() {
		return true
	}

	return false
}

// SetAuthenticationProviderIdentifier gets a reference to the given NullableString and assigns it to the AuthenticationProviderIdentifier field.
func (o *AuthenticationProviderDescription) SetAuthenticationProviderIdentifier(v string) {
	o.AuthenticationProviderIdentifier.Set(&v)
}

// SetAuthenticationProviderIdentifierNil sets the value for AuthenticationProviderIdentifier to be an explicit nil
func (o *AuthenticationProviderDescription) SetAuthenticationProviderIdentifierNil() {
	o.AuthenticationProviderIdentifier.Set(nil)
}

// UnsetAuthenticationProviderIdentifier ensures that no value is present for AuthenticationProviderIdentifier, not even an explicit nil
func (o *AuthenticationProviderDescription) UnsetAuthenticationProviderIdentifier() {
	o.AuthenticationProviderIdentifier.Unset()
}

func (o AuthenticationProviderDescription) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AuthenticationProviderDescription) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.PropertyDescriptions != nil {
		toSerialize["propertyDescriptions"] = o.PropertyDescriptions
	}
	if o.AuthenticationProviderIdentifier.IsSet() {
		toSerialize["authenticationProviderIdentifier"] = o.AuthenticationProviderIdentifier.Get()
	}
	return toSerialize, nil
}

type NullableAuthenticationProviderDescription struct {
	value *AuthenticationProviderDescription
	isSet bool
}

func (v NullableAuthenticationProviderDescription) Get() *AuthenticationProviderDescription {
	return v.value
}

func (v *NullableAuthenticationProviderDescription) Set(val *AuthenticationProviderDescription) {
	v.value = val
	v.isSet = true
}

func (v NullableAuthenticationProviderDescription) IsSet() bool {
	return v.isSet
}

func (v *NullableAuthenticationProviderDescription) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAuthenticationProviderDescription(val *AuthenticationProviderDescription) *NullableAuthenticationProviderDescription {
	return &NullableAuthenticationProviderDescription{value: val, isSet: true}
}

func (v NullableAuthenticationProviderDescription) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAuthenticationProviderDescription) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
